# Incentivized Black-Box Model Sharing

This repository is the official implementation of "Incentivized Black-Box Model Sharing". 


## Requirements

To install requirements:

```setup
conda env create -f environment.yml
```

Activate the conda environment:

```setup
conda activate cml_env
```

## Model Valuation

To validate the model valuation method under i.i.d. and non-i.i.d. data setting, run:

```
python valuation_correlation.py --dataset MNIST --iid_data 0 --num_users 5
```

To validate the model valuation method under heterogeneous model setting, run:

```
python valuation_model_heterogeneous.py
```

To validate the model valuation method with different ensemble methods, run:

```
python ensemble_correlation.py --dataset MNIST --num_users 5
```


## Model Sharing with Fair Rewards

To evaluate the model performance improvement with fair rewards, run:

```
python fair_model_sharing.py --dataset MNIST --val_size 5000
```

## Epsilon-Individual Rationality

To evaluate our Epsilon-Individual Rationality on MNIST and CIFAR-10, check:

```
# MNIST
get_alpha.ipynb

# CIFAR-10
get_alpha_cifar.ipynb
```


## Fair Reward and Payoff Allocation

To evaluate our fair utility function and compare with the baseline method, check:

```
utility_function.ipynb
```
